"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPluginOptionsGetter = void 0;
var lodash_1 = require("lodash");
var createPluginOptionsGetter = function (mergeWith, defaultOptions) { return function (options) {
    var pluginOptions = mergeWith(options);
    if ((0, lodash_1.isPlainObject)(pluginOptions)) {
        return (0, lodash_1.merge)({}, (0, lodash_1.isPlainObject)(defaultOptions) ? defaultOptions : {}, pluginOptions);
    }
    if ((0, lodash_1.isPlainObject)(defaultOptions)) {
        return defaultOptions;
    }
}; };
exports.createPluginOptionsGetter = createPluginOptionsGetter;
function createPluginCreator(target, enable, options) {
    if (enable === void 0) { enable = true; }
    return function (opt) {
        var didEnabled = enable;
        if ((0, lodash_1.isFunction)(enable)) {
            // @ts-ignore
            didEnabled = enable(opt);
        }
        if (!didEnabled) {
            return;
        }
        var plugin = [target];
        var pluginOptions = options;
        if ((0, lodash_1.isFunction)(options)) {
            // @ts-ignore
            pluginOptions = options(opt);
        }
        if ((0, lodash_1.isPlainObject)(pluginOptions)) {
            plugin.push(pluginOptions);
        }
        else if ((0, lodash_1.isPlainObject)(didEnabled)) {
            plugin.push(didEnabled);
        }
        return plugin;
    };
}
exports.default = createPluginCreator;
