"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var combineCreators_1 = __importDefault(require("./combineCreators"));
var createPluginCreator_1 = __importStar(require("./createPluginCreator"));
var createTransformRuntime = (0, createPluginCreator_1.default)(require('@babel/plugin-transform-runtime').default, true, function (options) {
    var absoluteRuntimePath = (options.useInternalRuntime &&
        (0, path_1.dirname)(require.resolve('@babel/runtime/package.json')));
    return {
        // Do not replace things like `Promise` or `Symbol`
        // with the library functions in `core-js`
        // https://babeljs.io/docs/en/babel-plugin-transform-runtime#corejs
        // https://babeljs.io/docs/en/next/babel-runtime-corejs2.html#difference-from-babel-runtime
        corejs: false,
        // Replace babel helpers with calls to moduleName
        // https://babeljs.io/docs/en/babel-plugin-transform-runtime#helpers
        // https://babeljs.io/docs/en/babel-plugin-transform-runtime#helper-aliasing
        helpers: true,
        // Transform generator functions to use a regenerator runtime
        // that does not pollute the global scope
        // https://babeljs.io/docs/en/babel-plugin-transform-runtime#regenerator
        // https://babeljs.io/docs/en/babel-plugin-transform-runtime#regenerator-aliasing
        regenerator: true,
        // Prefer ES6 Modules
        // https://babeljs.io/docs/en/babel-plugin-transform-runtime#useesmodules
        useESModules: options.esModules,
        // Resolving runtime in this package
        // https://github.com/babel/babel/blob/master/packages/babel-plugin-transform-runtime/src/index.js#L41
        absoluteRuntime: absoluteRuntimePath,
    };
});
var createFunctionBind = (0, createPluginCreator_1.default)(
// This proposal introduces a new operator ::
// which performs this binding and method extraction
// https://github.com/tc39/proposal-bind-operator
// https://babeljs.io/docs/en/next/babel-plugin-proposal-function-bind.html
require('@babel/plugin-proposal-function-bind'), function (options) { return options.proposal.functionBind; });
var createExportDefaultFrom = (0, createPluginCreator_1.default)(
// The export ___ from "module" statements are a very useful mechanism
// for building up "package" modules in a declarative way.
// https://github.com/tc39/proposal-export-default-from
// https://babeljs.io/docs/en/next/babel-plugin-proposal-export-default-from.html
require('@babel/plugin-proposal-export-default-from'), function (options) { return options.proposal.exportDefaultFrom; });
var createLogicalAssignmentOperators = (0, createPluginCreator_1.default)(
// To combine logical operators and assignment expressions.
// https://github.com/tc39/proposal-logical-assignment
// https://babeljs.io/docs/en/next/babel-plugin-proposal-logical-assignment-operators.html
require('@babel/plugin-proposal-logical-assignment-operators'), function (options) { return options.proposal.logicalAssignmentOperators; });
var createOptionalChaining = (0, createPluginCreator_1.default)(
// Allows to handle many of checking a property value
// whether intermediate nodes exist in a tree-like structure
// without repeating themselves and/or assigning intermediate results
// in temporary variables
// https://github.com/tc39/proposal-optional-chaining
// https://babeljs.io/docs/en/next/babel-plugin-proposal-optional-chaining.html
require('@babel/plugin-proposal-optional-chaining'), function (options) { return options.proposal.optionalChaining; }, (0, createPluginCreator_1.createPluginOptionsGetter)(function (options) { return options.proposal.optionalChaining; }, {
    // Strict equality checks against both null and undefined
    // https://babeljs.io/docs/en/next/babel-plugin-proposal-optional-chaining.html#loose
    loose: false,
}));
var createPipelineOperator = (0, createPluginCreator_1.default)(
// Make streamlining chained function calls in a readable,
// functional manner, and provides a practical alternative
// to extending built-in prototypes.
// https://github.com/tc39/proposal-pipeline-operator
// https://babeljs.io/docs/en/next/babel-plugin-proposal-pipeline-operator.html
require('@babel/plugin-proposal-pipeline-operator'), function (options) { return options.proposal.pipelineOperator; }, (0, createPluginCreator_1.createPluginOptionsGetter)(function (options) { return options.proposal.pipelineOperator; }, {
    // This plugin should use a configuration with the "proposal" option.
    // Only "minimal" is currently supported.
    // https://babeljs.io/docs/en/next/babel-plugin-proposal-pipeline-operator.html#via-babelrc-recommended
    proposal: 'minimal',
}));
var createNullishCoalescingOperator = (0, createPluginCreator_1.default)(
// To provide a default value if the result of that property access
// is null or undefined. At present, a typical way to express this intent
// in JavaScript is by using the `||` operator.
// https://github.com/tc39-transfer/proposal-nullish-coalescing
// https://babeljs.io/docs/en/babel-plugin-proposal-nullish-coalescing-operator
require('@babel/plugin-proposal-nullish-coalescing-operator'), function (options) { return options.proposal.nullishCoalescingOperator; }, (0, createPluginCreator_1.createPluginOptionsGetter)(function (options) { return options.proposal.nullishCoalescingOperator; }, {
    // To strict equality checks against both null and undefined
    // like proposal.optionalChaining.
    // https://babeljs.io/docs/en/babel-plugin-proposal-nullish-coalescing-operator#loose
    loose: false,
}));
var createDecorator = (0, createPluginCreator_1.default)(
// To make it possible to annotate and modify classes and properties
// at design time.
// https://github.com/wycats/javascript-decorators
// https://github.com/tc39/proposal-decorators
// https://babeljs.io/docs/en/next/babl-plugin-proposal-decorators.html
require('@babel/plugin-proposal-decorators'), function (options) { return options.proposal.decorators; }, (0, createPluginCreator_1.createPluginOptionsGetter)(function (options) { return options.proposal.decorators; }, {
    // Use the legacy (stage 1) decorators syntax and behavior.
    // https://babeljs.io/docs/en/next/babel-plugin-proposal-decorators.html#legacy
    legacy: true,
}));
var createFunctionSent = (0, createPluginCreator_1.default)(
// The value of function.sent within the body of a Generator Function
// is the value passed to the generator by the next method
// that most recently resumed execution of the generator.
// In particular, referencing `function.sent` prior
// to the first evaluation of a yield operator
// returns the argument value passed by the next call
// that started evaluation of the GeneratorBody.
// https://github.com/allenwb/ESideas/blob/master/Generator%20metaproperty.md
// https://babeljs.io/docs/en/next/babel-plugin-proposal-function-sent.html
require('@babel/plugin-proposal-function-sent'), function (options) { return options.proposal.functionSent; });
var createExportNamespaceFrom = (0, createPluginCreator_1.default)(
// The import statement which does not have corresponding
// export-from statement, exporting the `ModuleNameSpace` object
// as a named export.
// https://github.com/tc39/proposal-export-ns-from
// https://babeljs.io/docs/en/babel-plugin-proposal-export-namespace-from
require('@babel/plugin-proposal-export-namespace-from'), function (options) { return options.proposal.exportNamespaceFrom; });
var createNumericSeparator = (0, createPluginCreator_1.default)(
// to make their numeric literals more readable
// by creating a visual separation between groups of digits.
// https://github.com/tc39/proposal-numeric-separator
// https://babeljs.io/docs/en/babel-plugin-proposal-numeric-separator
require('@babel/plugin-proposal-numeric-separator'), function (options) { return options.proposal.numericSeparator; });
var createThrowExpressions = (0, createPluginCreator_1.default)(
// A throw expression allows you to throw exceptions
// in expression contexts.
// https://github.com/tc39/proposal-throw-expressions
// https://babeljs.io/docs/en/babel-plugin-proposal-throw-expressions
require('@babel/plugin-proposal-throw-expressions'), function (options) { return options.proposal.throwExpressions; });
var createDynamicImport = (0, createPluginCreator_1.default)(
// To provide a 'function-like' `import()` module loading syntactic
// form to JavaScript.
// https://github.com/tc39/proposal-dynamic-import
// https://babeljs.io/docs/en/babel-plugin-syntax-dynamic-import
require('@babel/plugin-syntax-dynamic-import'), function (options) { return options.proposal.dynamicImport; });
var createImportMeta = (0, createPluginCreator_1.default)(
// For holding host-specific metadata about the current module.
// https://github.com/tc39/proposal-import-meta
// https://babeljs.io/docs/en/babel-plugin-syntax-import-meta
require('@babel/plugin-syntax-import-meta'), function (options) { return options.proposal.importMeta; });
var createClassProperties = (0, createPluginCreator_1.default)(
// To support for 'Class instance fields' and 'Class static fields'
// https://github.com/jeffmo/es-class-static-properties-and-fields
// https://babeljs.io/docs/en/next/babel-plugin-proposal-class-properties.html
require('@babel/plugin-proposal-class-properties'), function (options) { return options.proposal.classProperties; }, (0, createPluginCreator_1.createPluginOptionsGetter)(function (options) { return options.proposal.classProperties; }, {
    // When `true`, class properties are compiled to
    // use an assignment expression instead of `Object.defineProperty`.
    // https://babeljs.io/docs/en/next/babel-plugin-proposal-class-properties.html#loose
    //
    // This plugin must be used in loose mode to support the
    // **@babel/plugin-proposal-decorators**
    // which using the `legacy: true` mode
    // https://babeljs.io/docs/en/next/babel-plugin-proposal-decorators.html#legacy
    loose: true,
}));
var createJSONStrings = (0, createPluginCreator_1.default)(
// To process valid JSON into valid ECMAScript before embedding it.
// https://github.com/tc39/proposal-json-superset
require('@babel/plugin-proposal-json-strings'), function (options) { return options.proposal.jsonStrings; });
var createPropertyMethods = (0, createPluginCreator_1.default)(
// Proposal: Private methods and getter/setters for JavaScript classes
// https://babeljs.io/docs/en/babel-plugin-proposal-private-methods
require('@babel/plugin-proposal-private-property-in-object'), function () { return ({
    // Note: The loose mode configuration setting must be the same as @babel/plugin-proposal-class-properties.
    //When true, private methods will be assigned directly 
    // on its parent via Object.defineProperty rather than a WeakSet. 
    // This results in improved performance and debugging (normal property access vs .get()) at 
    // the expense of potentially leaking "privates" via things like Object.getOwnPropertyNames.
    loose: true
}); });
var createRegExpModifies = (0, createPluginCreator_1.default)(require('@babel/plugin-proposal-regexp-modifiers'), function (options) { return options.proposal.regexpModifiers; });
exports.default = (0, combineCreators_1.default)([
    createTransformRuntime,
    createFunctionBind,
    createExportDefaultFrom,
    createLogicalAssignmentOperators,
    createOptionalChaining,
    createPipelineOperator,
    createNullishCoalescingOperator,
    createDecorator,
    createFunctionSent,
    createExportNamespaceFrom,
    createNumericSeparator,
    createThrowExpressions,
    createDynamicImport,
    createImportMeta,
    createClassProperties,
    createJSONStrings,
    createPropertyMethods,
    createRegExpModifies,
]);
