"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var helper_plugin_utils_1 = require("@babel/helper-plugin-utils");
var lodash_1 = require("lodash");
var createPlugins_1 = __importDefault(require("./createPlugins"));
var createPresets_1 = __importDefault(require("./createPresets"));
var defaultOptions_1 = __importDefault(require("./defaultOptions"));
exports.default = (0, helper_plugin_utils_1.declare)(function (api, options) {
    if (options === void 0) { options = {}; }
    api.assertVersion(7);
    var opts = (0, lodash_1.merge)({}, defaultOptions_1.default, options);
    var plugins = (0, createPlugins_1.default)(opts);
    var presets = (0, createPresets_1.default)(opts);
    return {
        plugins: plugins,
        presets: presets,
    };
});
