"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPluginOrPresetDeclaration = exports.isPluginOrPresetTarget = exports.isDevelopment = exports.isTest = exports.isProduction = void 0;
var lodash_1 = require("lodash");
var isProduction = function (env) { return env === 'production'; };
exports.isProduction = isProduction;
var isTest = function (env) { return env === 'test'; };
exports.isTest = isTest;
var isDevelopment = function (env) { return (!(0, exports.isProduction)(env) &&
    !(0, exports.isTest)(env)); };
exports.isDevelopment = isDevelopment;
var isPluginOrPresetTarget = function (value) { return ((0, lodash_1.isString)(value) ||
    (0, lodash_1.isObject)(value)); };
exports.isPluginOrPresetTarget = isPluginOrPresetTarget;
var isPluginOrPresetDeclaration = function (value) {
    if ((0, exports.isPluginOrPresetTarget)(value)) {
        return true;
    }
    if (Array.isArray(value)) {
        var target = value[0], options = value[1];
        return ((0, exports.isPluginOrPresetTarget)(target) &&
            ((0, lodash_1.isUndefined)(options) ||
                (0, lodash_1.isPlainObject)(options)));
    }
    return false;
};
exports.isPluginOrPresetDeclaration = isPluginOrPresetDeclaration;
